    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ------------------------
    028     * AreaRendererEndType.java
    029     * ------------------------
    030     * (C) Copyright 2004, 2005, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: AreaRendererEndType.java,v 1.4.2.1 2005/10/25 20:53:40 mungady Exp $
    036     *
    037     * Changes:
    038     * --------
    039     * 29-April-2004 : Version 1 (DG);
    040     *
    041     */
    042
    043    package org.jfree.chart.renderer;
    044
    045    import java.io.ObjectStreamException;
    046    import java.io.Serializable;
    047
    048    /**
    049     * An enumeration of the 'end types' for an area renderer.
    050     */
    051    public final class AreaRendererEndType implements Serializable {
    052
    053        /** For serialization. */
    054        private static final long serialVersionUID = -1774146392916359839L;
    055
    056        /**
    057         * The area tapers from the first or last value down to zero.
    058         */
    059        public static final AreaRendererEndType TAPER = new AreaRendererEndType(
    060            "AreaRendererEndType.TAPER"
    061        );
    062
    063        /**
    064         * The area is truncated at the first or last value.
    065         */
    066        public static final AreaRendererEndType TRUNCATE = new AreaRendererEndType(
    067            "AreaRendererEndType.TRUNCATE"
    068        );
    069
    070        /**
    071         * The area is levelled at the first or last value.
    072         */
    073        public static final AreaRendererEndType LEVEL = new AreaRendererEndType(
    074            "AreaRendererEndType.LEVEL"
    075        );
    076
    077        /** The name. */
    078        private String name;
    079
    080        /**
    081         * Private constructor.
    082         *
    083         * @param name  the name.
    084         */
    085        private AreaRendererEndType(String name) {
    086            this.name = name;
    087        }
    088
    089        /**
    090         * Returns a string representing the object.
    091         *
    092         * @return The string.
    093         */
    094        public String toString() {
    095            return this.name;
    096        }
    097
    098        /**
    099         * Returns <code>true</code> if this object is equal to the specified
    100         * object, and <code>false</code> otherwise.
    101         *
    102         * @param o  the other object.
    103         *
    104         * @return A boolean.
    105         */
    106        public boolean equals(Object o) {
    107
    108            if (this == o) {
    109                return true;
    110            }
    111            if (!(o instanceof AreaRendererEndType)) {
    112                return false;
    113            }
    114
    115            AreaRendererEndType t = (AreaRendererEndType) o;
    116            if (!this.name.equals(t.toString())) {
    117                return false;
    118            }
    119
    120            return true;
    121
    122        }
    123
    124        /**
    125         * Ensures that serialization returns the unique instances.
    126         *
    127         * @return The object.
    128         *
    129         * @throws ObjectStreamException if there is a problem.
    130         */
    131        private Object readResolve() throws ObjectStreamException {
    132            Object result = null;
    133            if (this.equals(AreaRendererEndType.LEVEL)) {
    134                result = AreaRendererEndType.LEVEL;
    135            }
    136            else if (this.equals(AreaRendererEndType.TAPER)) {
    137                result = AreaRendererEndType.TAPER;
    138            }
    139            else if (this.equals(AreaRendererEndType.TRUNCATE)) {
    140                result = AreaRendererEndType.TRUNCATE;
    141            }
    142            return result;
    143        }
    144
    145    }